(setq auto-mode-alist
      (append
       (list

	;; apache-mode
	'("\\.htaccess$"               . apache-mode)
	'("httpd\\.conf$"              . apache-mode)
	'("srm\\.conf$"                . apache-mode)
	'("access\\.conf$"             . apache-mode)
	'("apache[12]\?\\.conf$"       . apache-mode)
	'("commonapache[12]\?\\.conf$" . apache-mode)

	;; haskell-mode
	'("\\.l?hs$" . haskell-mode)

	;; octave-mode, the extension is a MATLAB relic.
	'("\\.m$" . octave-mode)

	;; nagios-mode
	'("\\.cfg$" . nagios-mode)

	;; nxml-mode
	'("\\.asp$"    . nxml-mode)
	'("\\.aspx$"   . nxml-mode)
	'("\\.xml$"    . nxml-mode)
	'("\\.?html$"  . nxml-mode)
	'("\\.config$" . nxml-mode)
	'("\\.tpl$"    . nxml-mode) ;; Smarty templates
	'("\\.rdf$"    . nxml-mode)
	'("\\.xul$"    . nxml-mode)

	;; php-mode
	'("\\.module$" . php-mode) ;; Drupal modules

	;; python-mode
	'("\\.pyx?$" . python-mode)

	;; ruby-mode
	'("\\.rake$"      . ruby-mode)
	'("/[Rr]akefile$" . ruby-mode)

	;; Perhaps surprisingly, I do not use Emacs as my PDF viewer.
	'("\\.pdf$" . fundamental-mode)
	)

       auto-mode-alist))
